#ifndef _OPENGL_GAME_H
#define _OPENGL_GAME_H

#include "IMGUI/imgui.h"
#include "imgui_impl_glfw_gl3.h"

#include "game-gui-glfw.hpp"
#include "graphics-pipeline_opengl.hpp"

class OpenGLGame {
   public:
      OpenGLGame();
      ~OpenGLGame();

      void run(int width, int height, unsigned char guiFlags);

   private:
      GameGui* gui;

      vector<GraphicsPipeline_OpenGL> graphicsPipelines;

      GLFWwindow* window;

      bool initWindow(int width, int height, unsigned char guiFlags);
      void initOpenGL();
      void mainLoop();
      void renderScene();
      void renderUI();
      void cleanup();
};

void APIENTRY opengl_debug_callback(
   GLenum source,
   GLenum type,
   GLuint id,
   GLenum severity,
   GLsizei length,
   const GLchar* message,
   const void* userParam
);

#endif // _OPENGL_GAME_H